diff --git a/packages/code-generator/.eslintignore b/packages/code-generator/.eslintignore
new file mode 100644
index 000000000..bcfd4b921
--- /dev/null
+++ b/packages/code-generator/.eslintignore
@@ -0,0 +1 @@
+test-cases/
diff --git a/packages/code-generator/demo/demo.js b/packages/code-generator/demo/demo.js
index 1c760446d..2b6e02f52 100644
--- a/packages/code-generator/demo/demo.js
+++ b/packages/code-generator/demo/demo.js
@@ -59,7 +59,9 @@ function main() {
 
   builder.generateProject(schemaJson).then((result) => {
     displayResultInConsole(result);
-    writeResultToDisk(result, 'output/lowcodeDemo').then((response) => console.log('Write to disk: ', JSON.stringify(response)));
+    writeResultToDisk(result, 'output/lowcodeDemo').then((response) =>
+      console.log('Write to disk: ', JSON.stringify(response)),
+    );
     return result;
   });
 }
@@ -160,12 +162,14 @@ function exportProject() {
 
   builder.generateProject(schemaJson).then((result) => {
     displayResultInConsole(result);
-    writeResultToDisk(result, 'output/lowcodeDemo').then((response) => console.log('Write to disk: ', JSON.stringify(response)));
+    writeResultToDisk(result, 'output/lowcodeDemo').then((response) =>
+      console.log('Write to disk: ', JSON.stringify(response)),
+    );
     return result;
   });
 }
 
 // main();
 // exportModule();
-// exportProject();
-demo();
+exportProject();
+// demo();
diff --git a/packages/code-generator/src/const/generator.ts b/packages/code-generator/src/const/generator.ts
index 3d3950420..11fe67b81 100644
--- a/packages/code-generator/src/const/generator.ts
+++ b/packages/code-generator/src/const/generator.ts
@@ -1,6 +1,7 @@
 export const COMMON_CHUNK_NAME = {
   ExternalDepsImport: 'CommonExternalDependencyImport',
   InternalDepsImport: 'CommonInternalDependencyImport',
+  ImportAliasDefine: 'CommonImportAliasDefine',
   FileVarDefine: 'CommonFileScopeVarDefine',
   FileUtilDefine: 'CommonFileScopeMethodDefine',
   FileMainContent: 'CommonFileMainContent',
@@ -21,24 +22,29 @@ export const CLASS_DEFINE_CHUNK_NAME = {
   InsVar: 'CommonClassDefineInsVar',
   InsVarMethod: 'CommonClassDefineInsVarMethod',
   InsMethod: 'CommonClassDefineInsMethod',
+  InsPrivateMethod: 'CommonClassDefineInsPrivateMethod',
   End: 'CommonClassDefineEnd',
 };
 
 export const DEFAULT_LINK_AFTER = {
   [COMMON_CHUNK_NAME.ExternalDepsImport]: [],
   [COMMON_CHUNK_NAME.InternalDepsImport]: [COMMON_CHUNK_NAME.ExternalDepsImport],
+  [COMMON_CHUNK_NAME.ImportAliasDefine]: [COMMON_CHUNK_NAME.ExternalDepsImport, COMMON_CHUNK_NAME.InternalDepsImport],
   [COMMON_CHUNK_NAME.FileVarDefine]: [
     COMMON_CHUNK_NAME.ExternalDepsImport,
     COMMON_CHUNK_NAME.InternalDepsImport,
+    COMMON_CHUNK_NAME.ImportAliasDefine,
   ],
   [COMMON_CHUNK_NAME.FileUtilDefine]: [
     COMMON_CHUNK_NAME.ExternalDepsImport,
     COMMON_CHUNK_NAME.InternalDepsImport,
+    COMMON_CHUNK_NAME.ImportAliasDefine,
     COMMON_CHUNK_NAME.FileVarDefine,
   ],
   [CLASS_DEFINE_CHUNK_NAME.Start]: [
     COMMON_CHUNK_NAME.ExternalDepsImport,
     COMMON_CHUNK_NAME.InternalDepsImport,
+    COMMON_CHUNK_NAME.ImportAliasDefine,
     COMMON_CHUNK_NAME.FileVarDefine,
     COMMON_CHUNK_NAME.FileUtilDefine,
   ],
@@ -49,20 +55,13 @@ export const DEFAULT_LINK_AFTER = {
     CLASS_DEFINE_CHUNK_NAME.InsVar,
     CLASS_DEFINE_CHUNK_NAME.InsVarMethod,
   ],
-  [CLASS_DEFINE_CHUNK_NAME.ConstructorContent]: [
-    CLASS_DEFINE_CHUNK_NAME.ConstructorStart,
-  ],
+  [CLASS_DEFINE_CHUNK_NAME.ConstructorContent]: [CLASS_DEFINE_CHUNK_NAME.ConstructorStart],
   [CLASS_DEFINE_CHUNK_NAME.ConstructorEnd]: [
     CLASS_DEFINE_CHUNK_NAME.ConstructorStart,
     CLASS_DEFINE_CHUNK_NAME.ConstructorContent,
   ],
-  [CLASS_DEFINE_CHUNK_NAME.StaticVar]: [
-    CLASS_DEFINE_CHUNK_NAME.Start,
-  ],
-  [CLASS_DEFINE_CHUNK_NAME.StaticMethod]: [
-    CLASS_DEFINE_CHUNK_NAME.Start,
-    CLASS_DEFINE_CHUNK_NAME.StaticVar,
-  ],
+  [CLASS_DEFINE_CHUNK_NAME.StaticVar]: [CLASS_DEFINE_CHUNK_NAME.Start],
+  [CLASS_DEFINE_CHUNK_NAME.StaticMethod]: [CLASS_DEFINE_CHUNK_NAME.Start, CLASS_DEFINE_CHUNK_NAME.StaticVar],
   [CLASS_DEFINE_CHUNK_NAME.InsVar]: [
     CLASS_DEFINE_CHUNK_NAME.Start,
     CLASS_DEFINE_CHUNK_NAME.StaticVar,
@@ -82,7 +81,7 @@ export const DEFAULT_LINK_AFTER = {
     CLASS_DEFINE_CHUNK_NAME.InsVarMethod,
     CLASS_DEFINE_CHUNK_NAME.ConstructorEnd,
   ],
-  [CLASS_DEFINE_CHUNK_NAME.End]: [
+  [CLASS_DEFINE_CHUNK_NAME.InsPrivateMethod]: [
     CLASS_DEFINE_CHUNK_NAME.Start,
     CLASS_DEFINE_CHUNK_NAME.StaticVar,
     CLASS_DEFINE_CHUNK_NAME.StaticMethod,
@@ -91,9 +90,20 @@ export const DEFAULT_LINK_AFTER = {
     CLASS_DEFINE_CHUNK_NAME.InsMethod,
     CLASS_DEFINE_CHUNK_NAME.ConstructorEnd,
   ],
+  [CLASS_DEFINE_CHUNK_NAME.End]: [
+    CLASS_DEFINE_CHUNK_NAME.Start,
+    CLASS_DEFINE_CHUNK_NAME.StaticVar,
+    CLASS_DEFINE_CHUNK_NAME.StaticMethod,
+    CLASS_DEFINE_CHUNK_NAME.InsVar,
+    CLASS_DEFINE_CHUNK_NAME.InsVarMethod,
+    CLASS_DEFINE_CHUNK_NAME.InsMethod,
+    CLASS_DEFINE_CHUNK_NAME.InsPrivateMethod,
+    CLASS_DEFINE_CHUNK_NAME.ConstructorEnd,
+  ],
   [COMMON_CHUNK_NAME.FileMainContent]: [
     COMMON_CHUNK_NAME.ExternalDepsImport,
     COMMON_CHUNK_NAME.InternalDepsImport,
+    COMMON_CHUNK_NAME.ImportAliasDefine,
     COMMON_CHUNK_NAME.FileVarDefine,
     COMMON_CHUNK_NAME.FileUtilDefine,
     CLASS_DEFINE_CHUNK_NAME.End,
@@ -101,6 +111,7 @@ export const DEFAULT_LINK_AFTER = {
   [COMMON_CHUNK_NAME.FileExport]: [
     COMMON_CHUNK_NAME.ExternalDepsImport,
     COMMON_CHUNK_NAME.InternalDepsImport,
+    COMMON_CHUNK_NAME.ImportAliasDefine,
     COMMON_CHUNK_NAME.FileVarDefine,
     COMMON_CHUNK_NAME.FileUtilDefine,
     CLASS_DEFINE_CHUNK_NAME.End,
diff --git a/packages/code-generator/src/generator/ChunkBuilder.ts b/packages/code-generator/src/generator/ChunkBuilder.ts
index 67ecd504e..d9dc8e3c6 100644
--- a/packages/code-generator/src/generator/ChunkBuilder.ts
+++ b/packages/code-generator/src/generator/ChunkBuilder.ts
@@ -21,6 +21,7 @@ export const groupChunks = (chunks: ICodeChunk[]): ICodeChunk[][] => {
   const col = chunks.reduce((chunksSet: Record<string, ChunkGroupInfo[]>, chunk) => {
     const fileKey = chunk.subModule || COMMON_SUB_MODULE_NAME;
     if (!chunksSet[fileKey]) {
+      // eslint-disable-next-line no-param-reassign
       chunksSet[fileKey] = [];
     }
     const res = whichFamily(chunk.fileType as FileType);
@@ -56,6 +57,7 @@ export const groupChunks = (chunks: ICodeChunk[]): ICodeChunk[][] => {
       let t: string = info.chunk.fileType;
       if (info.familyIdx !== undefined) {
         t = FILE_TYPE_FAMILY[info.familyIdx][tmp[key][info.familyIdx]];
+        // eslint-disable-next-line no-param-reassign
         info.chunk.fileType = t;
       }
       if (!byType[t]) {
diff --git a/packages/code-generator/src/generator/CodeBuilder.ts b/packages/code-generator/src/generator/CodeBuilder.ts
index 21b471f50..9a850d4a4 100644
--- a/packages/code-generator/src/generator/CodeBuilder.ts
+++ b/packages/code-generator/src/generator/CodeBuilder.ts
@@ -1,18 +1,13 @@
-import {
-  ChunkContent,
-  ChunkType,
-  CodeGeneratorError,
-  CodeGeneratorFunction,
-  ICodeBuilder,
-  ICodeChunk,
-} from '../types';
+import { ChunkContent, ChunkType, CodeGeneratorError, CodeGeneratorFunction, ICodeBuilder, ICodeChunk } from '../types';
 
 export default class Builder implements ICodeBuilder {
   private chunkDefinitions: ICodeChunk[] = [];
 
   private generators: { [key: string]: CodeGeneratorFunction<ChunkContent> } = {
-    [ChunkType.STRING]: (str: string) => str, // no-op for string chunks
-    [ChunkType.JSON]: (json: object) => JSON.stringify(json), // stringify json to string
+    // no-op for string chunks
+    [ChunkType.STRING]: (str: string) => str,
+    // stringify json to string
+    [ChunkType.JSON]: (json: Record<string, unknown>) => JSON.stringify(json),
   };
 
   constructor(chunkDefinitions: ICodeChunk[] = []) {
@@ -23,13 +18,13 @@ export default class Builder implements ICodeBuilder {
    * Links all chunks together based on their requirements. Returns an array
    * of ordered chunk names which need to be compiled and glued together.
    */
-  public link(chunkDefinitions: ICodeChunk[] = []): string {
+  link(chunkDefinitions: ICodeChunk[] = []): string {
     const chunks = chunkDefinitions || this.chunkDefinitions;
     if (chunks.length <= 0) {
       return '';
     }
 
-    const unprocessedChunks = chunks.map(chunk => {
+    const unprocessedChunks = chunks.map((chunk) => {
       return {
         name: chunk.name,
         type: chunk.type,
@@ -50,9 +45,7 @@ export default class Builder implements ICodeBuilder {
       }
 
       if (unprocessedChunks[indexToRemove].linkAfter.length > 0) {
-        throw new CodeGeneratorError(
-          'Operation aborted. Reason: cyclic dependency between chunks.',
-        );
+        throw new CodeGeneratorError('Operation aborted. Reason: cyclic dependency between chunks.');
       }
 
       const { type, content, name } = unprocessedChunks[indexToRemove];
@@ -62,10 +55,13 @@ export default class Builder implements ICodeBuilder {
       }
 
       unprocessedChunks.splice(indexToRemove, 1);
-      if (!unprocessedChunks.some(ch => ch.name === name)) {
+      if (!unprocessedChunks.some((ch) => ch.name === name)) {
         unprocessedChunks.forEach(
           // remove the processed chunk from all the linkAfter arrays from the remaining chunks
-          ch => (ch.linkAfter = ch.linkAfter.filter(after => after !== name)),
+          (ch) => {
+            // eslint-disable-next-line no-param-reassign
+            ch.linkAfter = ch.linkAfter.filter((after) => after !== name);
+          },
         );
       }
     }
@@ -73,14 +69,12 @@ export default class Builder implements ICodeBuilder {
     return resultingString.join('\n');
   }
 
-  public generateByType(type: string, content: unknown): string {
+  generateByType(type: string, content: unknown): string {
     if (!content) {
       return '';
     }
     if (Array.isArray(content)) {
-      return content
-        .map(contentItem => this.generateByType(type, contentItem))
-        .join('\n');
+      return content.map((contentItem) => this.generateByType(type, contentItem)).join('\n');
     }
 
     if (!this.generators[type]) {
@@ -95,6 +89,6 @@ export default class Builder implements ICodeBuilder {
   // remove invalid chunks (which did not end up being created) from the linkAfter fields
   // one use-case is when you want to remove the import plugin
   private cleanupInvalidChunks(linkAfter: string[], chunks: ICodeChunk[]) {
-    return linkAfter.filter(chunkName => chunks.some(chunk => chunk.name === chunkName));
+    return linkAfter.filter((chunkName) => chunks.some((chunk) => chunk.name === chunkName));
   }
 }
diff --git a/packages/code-generator/src/generator/ModuleBuilder.ts b/packages/code-generator/src/generator/ModuleBuilder.ts
index f70abc669..e31fdc58b 100644
--- a/packages/code-generator/src/generator/ModuleBuilder.ts
+++ b/packages/code-generator/src/generator/ModuleBuilder.ts
@@ -1,13 +1,12 @@
+import { ProjectSchema, ResultFile, ResultDir } from '@ali/lowcode-types';
+
 import {
   BuilderComponentPlugin,
   CodeGeneratorError,
-  IBasicSchema,
   ICodeChunk,
   ICompiledModule,
   IModuleBuilder,
   IParseResult,
-  IResultDir,
-  IResultFile,
   ISchemaParser,
   PostProcessor,
 } from '../types';
@@ -17,9 +16,7 @@ import { COMMON_SUB_MODULE_NAME } from '../const/generator';
 import SchemaParser from '../parser/SchemaParser';
 import ChunkBuilder from './ChunkBuilder';
 import CodeBuilder from './CodeBuilder';
-
-import ResultDir from '../model/ResultDir';
-import ResultFile from '../model/ResultFile';
+import { createResultFile, createResultDir, addFile } from '../utils/resultHelper';
 
 export function createModuleBuilder(
   options: {
@@ -40,24 +37,24 @@ export function createModuleBuilder(
       throw new CodeGeneratorError('No plugins found. Component generation cannot work without any plugins!');
     }
 
-    let files: IResultFile[] = [];
+    let files: ResultFile[] = [];
 
     const { chunks } = await chunkGenerator.run(input);
     chunks.forEach((fileChunkList) => {
       const content = linker.link(fileChunkList);
-      const file = new ResultFile(fileChunkList[0].subModule || moduleMainName, fileChunkList[0].fileType, content);
+      const file = createResultFile(fileChunkList[0].subModule || moduleMainName, fileChunkList[0].fileType, content);
       files.push(file);
     });
 
     if (options.postProcessors.length > 0) {
       files = files.map((file) => {
-        let { content } = file;
+        let content = file.content;
         const type = file.ext;
         options.postProcessors.forEach((processer) => {
           content = processer(content, type);
         });
 
-        return new ResultFile(file.name, type, content);
+        return createResultFile(file.name, type, content);
       });
     }
 
@@ -66,7 +63,7 @@ export function createModuleBuilder(
     };
   };
 
-  const generateModuleCode = async (schema: IBasicSchema | string): Promise<IResultDir> => {
+  const generateModuleCode = async (schema: ProjectSchema | string): Promise<ResultDir> => {
     // Init
     const schemaParser: ISchemaParser = new SchemaParser();
     const parseResult: IParseResult = schemaParser.parse(schema);
@@ -74,19 +71,19 @@ export function createModuleBuilder(
     const containerInfo = parseResult.containers[0];
     const { files } = await generateModule(containerInfo);
 
-    const dir = new ResultDir(containerInfo.moduleName);
-    files.forEach((file) => dir.addFile(file));
+    const dir = createResultDir(containerInfo.moduleName);
+    files.forEach((file) => addFile(dir, file));
 
     return dir;
   };
 
   const linkCodeChunks = (chunks: Record<string, ICodeChunk[]>, fileName: string) => {
-    const files: IResultFile[] = [];
+    const files: ResultFile[] = [];
 
     Object.keys(chunks).forEach((fileKey) => {
       const fileChunkList = chunks[fileKey];
       const content = linker.link(fileChunkList);
-      const file = new ResultFile(fileChunkList[0].subModule || fileName, fileChunkList[0].fileType, content);
+      const file = createResultFile(fileChunkList[0].subModule || fileName, fileChunkList[0].fileType, content);
       files.push(file);
     });
 
diff --git a/packages/code-generator/src/generator/ProjectBuilder.ts b/packages/code-generator/src/generator/ProjectBuilder.ts
index a10ad67e8..5486cd538 100644
--- a/packages/code-generator/src/generator/ProjectBuilder.ts
+++ b/packages/code-generator/src/generator/ProjectBuilder.ts
@@ -1,36 +1,35 @@
+import { ResultDir, ResultFile, ProjectSchema } from '@ali/lowcode-types';
+
 import {
   IModuleBuilder,
   IParseResult,
   IProjectBuilder,
   IProjectPlugins,
-  IProjectSchema,
   IProjectTemplate,
-  IResultDir,
-  IResultFile,
   ISchemaParser,
   PostProcessor,
 } from '../types';
 
-import ResultDir from '../model/ResultDir';
 import SchemaParser from '../parser/SchemaParser';
+import { createResultDir, addDirectory, addFile } from '../utils/resultHelper';
 
 import { createModuleBuilder } from '../generator/ModuleBuilder';
 
 interface IModuleInfo {
   moduleName?: string;
   path: string[];
-  files: IResultFile[];
+  files: ResultFile[];
 }
 
-function getDirFromRoot(root: IResultDir, path: string[]): IResultDir {
-  let current: IResultDir = root;
+function getDirFromRoot(root: ResultDir, path: string[]): ResultDir {
+  let current: ResultDir = root;
   path.forEach((p) => {
     const exist = current.dirs.find((d) => d.name === p);
     if (exist) {
       current = exist;
     } else {
-      const newDir = new ResultDir(p);
-      current.addDirectory(newDir);
+      const newDir = createResultDir(p);
+      addDirectory(current, newDir);
       current = newDir;
     }
   });
@@ -59,7 +58,7 @@ export class ProjectBuilder implements IProjectBuilder {
     this.postProcessors = postProcessors;
   }
 
-  async generateProject(schema: IProjectSchema | string): Promise<IResultDir> {
+  async generateProject(schema: ProjectSchema | string): Promise<ResultDir> {
     // Init
     const schemaParser: ISchemaParser = new SchemaParser();
     const builders = this.createModuleBuilders();
@@ -119,6 +118,27 @@ export class ProjectBuilder implements IProjectBuilder {
         files,
       });
     }
+
+    // appConfig
+    if (builders.appConfig) {
+      const { files } = await builders.appConfig.generateModule(parseResult);
+
+      buildResult.push({
+        path: this.template.slots.appConfig.path,
+        files,
+      });
+    }
+
+    // buildConfig
+    if (builders.buildConfig) {
+      const { files } = await builders.buildConfig.generateModule(parseResult);
+
+      buildResult.push({
+        path: this.template.slots.buildConfig.path,
+        files,
+      });
+    }
+
     // constants?
     if (parseResult.project && builders.constants && this.template.slots.constants) {
       const { files } = await builders.constants.generateModule(parseResult.project);
@@ -128,6 +148,7 @@ export class ProjectBuilder implements IProjectBuilder {
         files,
       });
     }
+
     // utils?
     if (parseResult.globalUtils && builders.utils && this.template.slots.utils) {
       const { files } = await builders.utils.generateModule(parseResult.globalUtils);
@@ -137,15 +158,17 @@ export class ProjectBuilder implements IProjectBuilder {
         files,
       });
     }
+
     // i18n?
-    if (parseResult.globalI18n && builders.i18n && this.template.slots.i18n) {
-      const { files } = await builders.i18n.generateModule(parseResult.globalI18n);
+    if (builders.i18n && this.template.slots.i18n) {
+      const { files } = await builders.i18n.generateModule(parseResult.project);
 
       buildResult.push({
         path: this.template.slots.i18n.path,
         files,
       });
     }
+
     // globalStyle
     if (parseResult.project && builders.globalStyle) {
       const { files } = await builders.globalStyle.generateModule(parseResult.project);
@@ -155,6 +178,7 @@ export class ProjectBuilder implements IProjectBuilder {
         files,
       });
     }
+
     // htmlEntry
     if (parseResult.project && builders.htmlEntry) {
       const { files } = await builders.htmlEntry.generateModule(parseResult.project);
@@ -164,6 +188,7 @@ export class ProjectBuilder implements IProjectBuilder {
         files,
       });
     }
+
     // packageJSON
     if (parseResult.project && builders.packageJSON) {
       const { files } = await builders.packageJSON.generateModule(parseResult.project);
@@ -174,17 +199,19 @@ export class ProjectBuilder implements IProjectBuilder {
       });
     }
 
+    // TODO: 更多 slots 的处理？？是不是可以考虑把 template 中所有的 slots 都处理下？
+
     // Post Process
 
     // Combine Modules
     buildResult.forEach((moduleInfo) => {
       let targetDir = getDirFromRoot(projectRoot, moduleInfo.path);
       if (moduleInfo.moduleName) {
-        const dir = new ResultDir(moduleInfo.moduleName);
-        targetDir.addDirectory(dir);
+        const dir = createResultDir(moduleInfo.moduleName);
+        addDirectory(targetDir, dir);
         targetDir = dir;
       }
-      moduleInfo.files.forEach((file) => targetDir.addFile(file));
+      moduleInfo.files.forEach((file) => addFile(targetDir, file));
     });
 
     return projectRoot;
diff --git a/packages/code-generator/src/index.ts b/packages/code-generator/src/index.ts
index 79e527354..3d368be5a 100644
--- a/packages/code-generator/src/index.ts
+++ b/packages/code-generator/src/index.ts
@@ -7,7 +7,8 @@ import { createModuleBuilder } from './generator/ModuleBuilder';
 import { createDiskPublisher } from './publisher/disk';
 import { createZipPublisher } from './publisher/zip';
 import createIceJsProjectBuilder from './solutions/icejs';
-import createRecoreProjectBuilder from './solutions/recore';
+// import createRecoreProjectBuilder from './solutions/recore';
+import createRaxAppProjectBuilder from './solutions/rax-app';
 
 // 引入说明
 import { REACT_CHUNK_NAME } from './plugins/component/react/const';
@@ -34,11 +35,15 @@ import prettier from './postprocessor/prettier';
 import * as utilsCommon from './utils/common';
 import * as utilsCompositeType from './utils/compositeType';
 import * as utilsJsExpression from './utils/jsExpression';
+import * as utilsJsSlot from './utils/jsSlot';
 import * as utilsNodeToJSX from './utils/nodeToJSX';
+import * as utilsResultHelper from './utils/resultHelper';
 import * as utilsTemplateHelper from './utils/templateHelper';
+import * as utilsValidate from './utils/validate';
 
 // 引入内置解决方案模块
 import icejs from './plugins/project/framework/icejs';
+import rax from './plugins/project/framework/rax';
 
 export * from './types';
 
@@ -47,10 +52,12 @@ export default {
   createModuleBuilder,
   solutions: {
     icejs: createIceJsProjectBuilder,
-    recore: createRecoreProjectBuilder,
+    // recore: createRecoreProjectBuilder,
+    rax: createRaxAppProjectBuilder,
   },
   solutionParts: {
     icejs,
+    rax,
   },
   publishers: {
     disk: createDiskPublisher,
@@ -87,8 +94,11 @@ export default {
     common: utilsCommon,
     compositeType: utilsCompositeType,
     jsExpression: utilsJsExpression,
+    jsSlot: utilsJsSlot,
     nodeToJSX: utilsNodeToJSX,
+    resultHelper: utilsResultHelper,
     templateHelper: utilsTemplateHelper,
+    validate: utilsValidate,
   },
   chunkNames: {
     COMMON_CHUNK_NAME,
diff --git a/packages/code-generator/src/parser/SchemaParser.ts b/packages/code-generator/src/parser/SchemaParser.ts
index 61ca7c806..b05df3ec5 100644
--- a/packages/code-generator/src/parser/SchemaParser.ts
+++ b/packages/code-generator/src/parser/SchemaParser.ts
@@ -2,30 +2,28 @@
  * 解析器是对输入的固定格式数据做拆解，使其符合引擎后续步骤预期，完成统一处理逻辑的步骤。
  * 本解析器面向的是标准 schema 协议。
  */
+import changeCase from 'change-case';
+import { UtilItem, NodeDataType, NodeSchema, ContainerSchema, ProjectSchema, PropsMap } from '@ali/lowcode-types';
 
 import { SUPPORT_SCHEMA_VERSION_LIST } from '../const';
 
-import { handleSubNodes } from '../utils/nodeToJSX';
+import { handleSubNodes } from '../utils/schema';
 import { uniqueArray } from '../utils/common';
 
 import {
-  ChildNodeType,
   CodeGeneratorError,
   CompatibilityError,
   DependencyType,
-  IBasicSchema,
-  IComponentNodeItem,
   IContainerInfo,
-  IContainerNodeItem,
+  IDependency,
   IExternalDependency,
   IInternalDependency,
   InternalDependencyType,
-  IPageMeta,
   IParseResult,
-  IProjectSchema,
   ISchemaParser,
-  IUtilItem,
   INpmPackage,
+  IRouterInfo,
+  IPageMeta,
 } from '../types';
 
 const defaultContainer: IContainerInfo = {
@@ -38,7 +36,7 @@ const defaultContainer: IContainerInfo = {
 };
 
 class SchemaParser implements ISchemaParser {
-  validate(schema: IBasicSchema): boolean {
+  validate(schema: ProjectSchema): boolean {
     if (SUPPORT_SCHEMA_VERSION_LIST.indexOf(schema.version) < 0) {
       throw new CompatibilityError(`Not support schema with version [${schema.version}]`);
     }
@@ -46,13 +44,13 @@ class SchemaParser implements ISchemaParser {
     return true;
   }
 
-  parse(schemaSrc: IProjectSchema | string): IParseResult {
+  parse(schemaSrc: ProjectSchema | string): IParseResult {
     // TODO: collect utils depends in JSExpression
     const compDeps: Record<string, IExternalDependency> = {};
     const internalDeps: Record<string, IInternalDependency> = {};
     let utilsDeps: IExternalDependency[] = [];
 
-    let schema: IProjectSchema;
+    let schema: ProjectSchema;
     if (typeof schemaSrc === 'string') {
       try {
         schema = JSON.parse(schemaSrc);
@@ -65,31 +63,38 @@ class SchemaParser implements ISchemaParser {
 
     // 解析三方组件依赖
     schema.componentsMap.forEach((info) => {
-      info.dependencyType = DependencyType.External;
-      info.importName = info.componentName;
-      compDeps[info.componentName] = info;
+      if (info.componentName) {
+        compDeps[info.componentName] = {
+          ...info,
+          dependencyType: DependencyType.External,
+          componentName: info.componentName,
+          exportName: info.exportName ?? info.componentName,
+          version: info.version || '*',
+          destructuring: info.destructuring ?? false,
+        };
+      }
     });
 
     let containers: IContainerInfo[];
     // Test if this is a lowcode component without container
     if (schema.componentsTree.length > 0) {
-      const firstRoot: IContainerNodeItem = schema.componentsTree[0] as IContainerNodeItem;
+      const firstRoot: ContainerSchema = schema.componentsTree[0] as ContainerSchema;
 
-      if (!firstRoot.fileName) {
+      if (!('fileName' in firstRoot) || !firstRoot.fileName) {
         // 整个 schema 描述一个容器，且无根节点定义
         const container: IContainerInfo = {
           ...defaultContainer,
-          children: schema.componentsTree as IComponentNodeItem[],
+          children: schema.componentsTree as NodeSchema[],
         };
         containers = [container];
       } else {
         // 普通带 1 到多个容器的 schema
         containers = schema.componentsTree.map((n) => {
-          const subRoot = n as IContainerNodeItem;
+          const subRoot = n as ContainerSchema;
           const container: IContainerInfo = {
             ...subRoot,
             containerType: subRoot.componentName,
-            moduleName: subRoot.fileName, // TODO: 驼峰化名称
+            moduleName: changeCase.pascalCase(subRoot.fileName),
           };
           return container;
         });
@@ -124,6 +129,7 @@ class SchemaParser implements ISchemaParser {
       internalDeps[dep.moduleName] = dep;
     });
 
+    const containersDeps = ([] as IDependency[]).concat(...containers.map((c) => c.deps || []));
     // TODO: 不应该在出码部分解决？
     // 处理 children 写在了 props 里的情况
     containers.forEach((container) => {
@@ -131,11 +137,18 @@ class SchemaParser implements ISchemaParser {
         handleSubNodes<string>(
           container.children,
           {
-            node: (i: IComponentNodeItem) => {
-              if (i.props && i.props.children && !i.children) {
-                i.children = i.props.children as ChildNodeType;
+            node: (i: NodeSchema) => {
+              if (i.props) {
+                if (Array.isArray(i.props)) {
+                  // FIXME: is array type props description
+                } else {
+                  const nodeProps = i.props as PropsMap;
+                  if (nodeProps.children && !i.children) {
+                    i.children = nodeProps.children as NodeDataType;
+                  }
+                }
               }
-              return [''];
+              return '';
             },
           },
           {
@@ -157,18 +170,21 @@ class SchemaParser implements ISchemaParser {
     });
 
     // 分析路由配置
-    const routes = containers
+    const routes: IRouterInfo['routes'] = containers
       .filter((container) => container.containerType === 'Page')
       .map((page) => {
-        const meta = page.meta as IPageMeta;
+        const meta = page.meta;
         if (meta) {
           return {
-            path: meta.router,
+            path: (meta as IPageMeta).router || `/${page.fileName}`, // 如果无法找到页面路由信息，则用 fileName 做兜底
+            fileName: page.fileName,
             componentName: page.moduleName,
           };
         }
+
         return {
           path: '',
+          fileName: page.fileName,
           componentName: page.moduleName,
         };
       });
@@ -178,7 +194,7 @@ class SchemaParser implements ISchemaParser {
       .filter((dep) => !!dep);
 
     // 分析 Utils 依赖
-    let utils: IUtilItem[];
+    let utils: UtilItem[];
     if (schema.utils) {
       utils = schema.utils;
       utilsDeps = schema.utils.filter((u) => u.type !== 'function').map((u) => u.content as IExternalDependency);
@@ -190,7 +206,7 @@ class SchemaParser implements ISchemaParser {
     let npms: INpmPackage[] = [];
     containers.forEach((con) => {
       const p = (con.deps || [])
-        .map((dep) => (dep.dependencyType === DependencyType.External ? dep : null))
+        .map((dep) => { return (dep.dependencyType === DependencyType.External) ? dep : null; })
         .filter((dep) => dep !== null);
       npms.push(...((p as unknown) as INpmPackage[]));
     });
@@ -208,21 +224,21 @@ class SchemaParser implements ISchemaParser {
         deps: routerDeps,
       },
       project: {
-        meta: schema.meta,
-        config: schema.config,
         css: schema.css,
         constants: schema.constants,
         i18n: schema.i18n,
+        containersDeps,
+        utilsDeps,
         packages: npms,
       },
     };
   }
 
-  getComponentNames(children: ChildNodeType): string[] {
+  getComponentNames(children: NodeDataType): string[] {
     return handleSubNodes<string>(
       children,
       {
-        node: (i: IComponentNodeItem) => [i.componentName],
+        node: (i: NodeSchema) => i.componentName,
       },
       {
         rerun: true,
